From eaf52b69494bfb9f6b478ed7586beb0e98ce8f78 Mon Sep 17 00:00:00 2001
From: Daniel Stenberg <daniel@haxx.se>
Date: Thu, 23 Nov 2023 08:15:47 +0100
Subject: cookie: lowercase the domain names before PSL checks

Reported-by: Harry Sintonen

Closes #12387
---
 lib/cookie.c | 34 +++++++++++++++++++++++-----------
 1 file changed, 23 insertions(+), 11 deletions(-)

diff --git a/lib/cookie.c b/lib/cookie.c
index 9db505744..04b7de4fa 100644
--- a/lib/cookie.c
+++ b/lib/cookie.c
@@ -933,19 +933,31 @@ Curl_cookie_add(struct Curl_easy *data,
     remove_expired(c);
 
   if(domain && co->domain && !isip(co->domain)) {
-    int acceptable;
 #ifdef USE_LIBPSL
-    const psl_ctx_t *psl = Curl_psl_use(data);
-
-    /* Check if the domain is a Public Suffix and if yes, ignore the cookie. */
-    if(psl) {
-      acceptable = psl_is_cookie_domain_acceptable(psl, domain, co->domain);
-      Curl_psl_release(data);
-    }
-    else
+  /*
+   * Check if the domain is a Public Suffix and if yes, ignore the cookie. We
+   * must also check that the data handle isn't NULL since the psl code will
+   * dereference it.
+   */
+    bool acceptable = FALSE;
+    char lcase[256];
+    char lcookie[256];
+    size_t dlen = strlen(domain);
+    size_t clen = strlen(co->domain);
+    if((dlen < sizeof(lcase)) && (clen < sizeof(lcookie))) {
+      const psl_ctx_t *psl = Curl_psl_use(data);
+      if(psl) {
+        /* the PSL check requires lowercase domain name and pattern */
+        Curl_strntolower(lcase, domain, dlen + 1);
+        Curl_strntolower(lcookie, co->domain, clen + 1);
+        acceptable = psl_is_cookie_domain_acceptable(psl, lcase, lcookie);
+        Curl_psl_release(data);
+      }
+      else
 #endif
-    /* Without libpsl, do the best we can. */
-    acceptable = !bad_domain(co->domain);
+        /* Without libpsl, do the best we can. */
+        acceptable = !bad_domain(co->domain);
+    }
 
     if(!acceptable) {
       infof(data, "cookie '%s' dropped, domain '%s' must not "
-- 
2.30.2

